<template>
  <v-card outlined>
    <v-row align="center">
      <v-col cols="8" md="10">
        <v-card-title>
          <v-checkbox v-model="timer">
            <template v-slot:label>Timer</template></v-checkbox>
        </v-card-title>
        <v-card-subtitle>A simple countdown to time the duration of the current experiment</v-card-subtitle>
      </v-col>
      <v-col>
        <v-icon x-large>mdi-camera-timer</v-icon>
      </v-col>
    </v-row>
    <v-card-text>
      <v-slider
        v-model="timer_duration"
        :disabled="!timer"
        :min="min_duration"
        :max="max_duration"
        default="35"
        label="Duration"
        step="1"
        ticks
        thumb-label
      >
        <template v-slot:append>
          <v-text-field
            v-model="timer_duration"
            :min="min_duration"
            :max="max_duration"
            class="mt-0 pt-0"
            hide-details
            single-line
            type="number"
            style="width: 60px"
          ></v-text-field>
        </template>
      </v-slider>
      <v-checkbox
        v-model="timer_disconnect"
        :disabled="!timer"
        :label="'Disconnect board on finish'"
      ></v-checkbox>
    </v-card-text>
  </v-card>
</template>

<script>
export default {
  name: "TimerSettings",
  data: () => ({
    min_duration: 1,
    max_duration: 60,
  }),
  computed: {
    timer: {
      get() {
        return this.$store.getters["settings/timer"].timer;
      },
      set(value) {
        this.$store.dispatch("settings/updateTimer", { timer: value });
      },
    },
    timer_duration: {
      get() {
        return this.$store.getters["settings/timer"].timer_duration;
      },
      set(value) {
        this.$store.dispatch("settings/updateTimer", { timer_duration: value });
      },
    },
    timer_disconnect: {
      get() {
        return this.$store.getters["settings/timer"].timer_disconnect;
      },
      set(value) {
        this.$store.dispatch("settings/updateTimer", {
          timer_disconnect: value,
        });
      },
    },
  },
};
</script>